<template>
  <div id="resourcecreation">
    <coscine-headline :headline="$t('title')" />
    <b-nav tabs justified>
      <b-nav-item
        :active="this.$router.currentRoute.path == '/Setup'"
        :disabled="!componentAllowed.Setup"
        @click.prevent="switchPage('Setup')"
        @switchPage="switchPage(currentRoute)"
      >
        {{ $t("stepSetup") }}
      </b-nav-item>
      <b-nav-item
        :active="this.$router.currentRoute.path == '/GeneralInfo'"
        :disabled="!componentAllowed.GeneralInfo"
        @click.prevent="switchPage('GeneralInfo')"
        @switchPage="switchPage(currentRoute)"
      >
        {{ $t("stepGeneralInfo") }}
      </b-nav-item>
      <b-nav-item
        :active="this.$router.currentRoute.path == '/Metadata'"
        :disabled="!componentAllowed.Metadata"
        @click.prevent="switchPage('Metadata')"
        @switchPage="switchPage(currentRoute)"
      >
        {{ $t("stepMetadata") }}
      </b-nav-item>
      <b-nav-item
        :active="this.$router.currentRoute.path == '/Overview'"
        :disabled="!componentAllowed.Overview"
        @click.prevent="switchPage('Overview')"
        @switchPage="switchPage(currentRoute)"
      >
        {{ $t("stepOverview") }}
      </b-nav-item>
    </b-nav>
    <div class="container">
      <b-row>
        <div class="col-sm-2"></div>
        <div class="col-sm-8">
          <router-view
            class="resourceComponent"
            :applicationProfileList="applicationProfileList"
            :currentComponent="currentComponent"
            :isProjectOwner="isProjectOwner"
            :isOwner="isOwner"
            :emailAddressIsValid="emailAddressIsValid"
            :isWaitingForResponse="isWaitingForResponse"
            :finishedLoadingResourceTypes="finishedLoadingResourceTypes"
            :projectId="projectId"
            :resource="resource"
            :resourceTypes="resourceTypes"
            :selectedResourceTypeInformation="selectedResourceTypeInformation"
            :applicationProfile="applicationProfile"
            @back="back"
            @switchPage="switchPage"
            @next="next"
            @waitingForResponse="setWaitingForResponse"
            @setSelectedResourceTypeInformation="
              setSelectedResourceTypeInformation
            "
          />
          <coscine-loading-spinner
            :isWaitingForResponse="isWaitingForResponse"
          ></coscine-loading-spinner>
        </div>
        <div class="col-sm-2"></div>
      </b-row>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import {
  ProjectApi,
  ProjectRoleApi,
  ResourceTypeApi,
  MetadataApi,
  ResourceApi,
} from "@coscine/api-connection";
import { LanguageUtil, GuidUtil } from "@coscine/app-util";
import {
  CoscineLoadingSpinner,
  CoscineHeadline,
} from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

const componentList = ["Setup", "GeneralInfo", "Metadata", "Overview"];

const componentAllowed = {} as any;
for (const component of componentList) {
  componentAllowed[component] = false;
}
componentAllowed.Setup = true;

// TODO: Parse id if on viewResource page
const componentId = 0;

export default Vue.extend({
  name: "resourcecreation",
  data() {
    return {
      // TODO: Set Overview component when on ViewResource page
      componentId,
      componentList,
      componentAllowed,
      currentComponent: componentList[componentId],
      resource: {
        ResourceName: "",
        DisplayName: "",
        Description: "",
        PID: "",
        Disciplines: [] as Array<unknown>,
        Keywords: [] as Array<unknown>,
        Visibility: {
          id: "",
          displayName: "",
        },
        License: null,
        UsageRights: "",
        type: {
          id: "",
          displayName: "",
          enabled: true,
        },
        applicationProfile: "",
        fixedValues: {},
        resourceTypeOption: {},
      },
      resourceTypes: [] as Array<unknown>,
      selectedResourceTypeInformation: {},
      applicationProfileList: [] as Array<unknown>,
      applicationProfile: [] as any[],
      projectId: "",
      isProjectOwner: false,
      isOwner: false,
      emailAddressIsValid: false,
      finishedLoadingResourceTypes: false,
      isWaitingForResponse: false,
    };
  },
  watch: {
    "resource.applicationProfile"() {
      if (this.resource.applicationProfile !== "") {
        MetadataApi.getProfile(
          this.resource.applicationProfile,
          (response: any) => {
            this.applicationProfile = response.data;
          }
        );
      }
    },
  },
  methods: {
    setWaitingForResponse(newIsWaitingForResponse: boolean) {
      this.isWaitingForResponse = newIsWaitingForResponse;
    },
    setSelectedResourceTypeInformation(
      newSelectedResourceTypeInformation: any
    ) {
      if (
        this.selectedResourceTypeInformation !== null &&
        this.selectedResourceTypeInformation != undefined &&
        newSelectedResourceTypeInformation !== null &&
        newSelectedResourceTypeInformation != undefined &&
        (this.selectedResourceTypeInformation as any).id !==
          newSelectedResourceTypeInformation.id
      ) {
        const type = {
          id: newSelectedResourceTypeInformation.id,
          displayName: newSelectedResourceTypeInformation.displayName,
          enabled: newSelectedResourceTypeInformation.isEnabled,
        };
        const resourceTypeOptions = {};
        for (const key of newSelectedResourceTypeInformation.resourceCreate
          .components[0]) {
          (resourceTypeOptions as any)[key] = undefined;
        }
        this.$set(this.resource, "type", type);
        this.$set(this.resource, "resourceTypeOption", resourceTypeOptions);
        this.selectedResourceTypeInformation =
          newSelectedResourceTypeInformation;
      }
    },
    back() {
      this.componentId = this.componentId - 1;
      this.currentComponent = componentList[this.componentId];
      this.$router.push(this.currentComponent);
    },
    next() {
      this.componentId = this.componentId + 1;
      this.currentComponent = componentList[this.componentId];
      componentAllowed[this.currentComponent] = true;
      this.$router.push(this.currentComponent);
    },
    switchPage(component: string) {
      this.currentComponent = component;
      this.componentId = componentList.indexOf(component);
      this.$router.push(this.currentComponent);
    },
    fillForm(data: any) {
      this.resource.ResourceName = data.resourceName;
      this.resource.DisplayName = data.displayName;
      this.resource.Description = data.description;
      this.resource.UsageRights = data.usageRights;
      this.resource.Keywords = [] as Array<unknown>;
      const keywords = data.keywords ? data.keywords.split(";") : [];
      this.resource.Keywords = keywords;
      this.resource.Disciplines = [] as Array<unknown>;
      for (const discipline of Object.keys(data.disciplines)) {
        this.resource.Disciplines.push(data.disciplines[discipline]);
      }
      this.resource.Visibility = data.visibility;
      this.resource.PID = data.pid;
      this.resource.License = data.license;
      this.resource.type = data.type;
      this.resource.resourceTypeOption = data.resourceTypeOption;
      this.resource.applicationProfile =
        data.applicationProfile !== null ? data.applicationProfile : "";
      this.resource.fixedValues =
        data.fixedValues !== null ? data.fixedValues : {};
      this.$forceUpdate();
      return;
    },
    checkOwnership(projectRoles: any) {
      for (const projectRole in projectRoles) {
        if (projectRoles[projectRole].role.displayName === "Owner") {
          this.isProjectOwner = true;
          this.isOwner = true;
        }
      }
    },
    checkEmailAddressValid(projectRoles: any) {
      for (const projectRole in projectRoles) {
        if (projectRoles[projectRole].user.emailAddress !== "") {
          this.emailAddressIsValid = true;
        }
      }
    },
    getApplicationProfileList() {
      MetadataApi.getProfiles((response: any) => {
        this.applicationProfileList = [];
        for (const applicationProfile of response.data.sort()) {
          let text = applicationProfile.replace(
            "https://purl.org/coscine/ap/",
            ""
          );
          if (text.charAt(text.length - 1) === "/") {
            text = text.substring(0, text.lastIndexOf("/"));
          }
          if (text.lastIndexOf("/") !== -1) {
            let indexOfSlash = text.lastIndexOf("/");
            let groupName = text.substring(0, indexOfSlash).toUpperCase();
            let optionName = text
              .substring(indexOfSlash + 1)
              .firstToUpperCase();
            let option = {
              value: applicationProfile.toString(),
              text: optionName,
            };
            let groupEntry = this.applicationProfileList.find(
              (element) => (element as any)["label"] === groupName
            );
            let indexOfGroupEntry = this.applicationProfileList.indexOf(
              groupEntry as any
            );
            if (groupEntry !== undefined) {
              (groupEntry as any)["options"].push(option);
              this.applicationProfileList.splice(
                indexOfGroupEntry,
                1,
                groupEntry
              );
            } else {
              this.applicationProfileList.push({
                label: groupName,
                options: [option],
              });
            }
          } else {
            this.applicationProfileList.push({
              value: applicationProfile.toString(),
              text: text.firstToUpperCase(),
            });
          }
        }
        if (this.applicationProfileList.length === 1) {
          this.$set(
            this.resource,
            "applicationProfile",
            (this.applicationProfileList[0] as any).value
          );
        }
      });
    },
    getResourceTypeInformation(id: string): any {
      for (const resourceTypeInformation of this.resourceTypes) {
        if ((resourceTypeInformation as any).id === id) {
          return resourceTypeInformation;
        }
      }
    },
  },
  components: {
    CoscineLoadingSpinner,
    CoscineHeadline,
  },
  beforeCreate() {
    if (
      location.hash !== "#/Setup" &&
      location.hash !== "#/GeneralInfo" &&
      location.hash !== "#/Metadata" &&
      location.hash !== "#/Overview"
    ) {
      if (
        GuidUtil.isValidGuid(
          new URL(window.location.href).searchParams.get("resource_id")
        )
      ) {
        location.hash = "#/Overview";
      } else {
        location.hash = "#/Setup";
      } 
    }
  },
  created() {
    this.projectId = GuidUtil.getProjectId();
    this.getApplicationProfileList();

    if (GuidUtil.isValidGuid(this.projectId)) {
      ProjectRoleApi.getUserRoles(this.projectId, (response: any) => {
        this.checkOwnership(response.data);
        this.checkEmailAddressValid(response.data);
      });
    }
    this.componentId = 0;
    ResourceTypeApi.getEnabledResourceTypes((response: any) => {
      this.resourceTypes = [];
      for (const resourceType of response.data) {
        resourceType.iDisplayName = this.$t(
          "ResourceTypes." + resourceType.displayName + ".displayName"
        );
        resourceType.iFullName = this.$t(
          "ResourceTypes." + resourceType.displayName + ".fullName"
        );
        resourceType.iDescription = this.$t(
          "ResourceTypes." + resourceType.displayName + ".description"
        );
        this.resourceTypes.push(resourceType);
      }
      if (this.resourceTypes.length === 1) {
        this.setSelectedResourceTypeInformation(this.resourceTypes[0]);
      } else {
        this.resourceTypes.sort((a: any, b: any) =>
          a.iDisplayName < b.iDisplayName
            ? -1
            : a.iDisplayName > b.iDisplayName
            ? 1
            : 0
        );
      }
      this.finishedLoadingResourceTypes = true;
    });
  },
});
</script>

<style>
#resourcecreation .col-form-label {
  font-weight: bold;
}
.multiselect {
  height: auto !important;
}
.multiselect__tag {
  background-color: #00549f !important;
}
.multiselect__option--highlight {
  background: #00549f !important;
}
.multiselect__option--selected.multiselect__option--highlight {
  background: #00549f !important;
}
.multiselect__content-wrapper {
  overflow-x: hidden;
  text-overflow: ellipsis;
}
</style>

<style scoped>
#resourcecreation {
  width: 100%;
  border: 1px solid rgba(0, 0, 0, 0.125);
  border-radius: 0.2rem;
  padding: 1em;
}
.float-right {
  float: right;
}
.invalid-tooltip {
  position: absolute;
  top: 100%;
  z-index: 5;
  display: none;
  max-width: 100%;
  padding: 0.25rem 0.5rem;
  margin-top: 0.1rem;
  font-size: 0.76563rem;
  line-height: 1.4;
  color: #fff;
  background-color: rgba(204, 7, 30, 0.9);
  border-radius: 0;
}
.resourceComponent {
  margin-top: 1em;
}
</style>
